function getMyDSID() {
	return Property.getProperty('/system/dSID');
}

function getDSMPIDForZone(zoneID) {
    lInfo.logln('determine dsm for ' + zoneID);
    var zZone = getZoneByID(parseInt('' + zoneID, 10));
    var config = zZone.getTemperatureControlConfiguration();
    return config.ControlDSUID;
}

function preventUninstall() {
	var fPrevent=false;
    var oZoneArray=Property.getNode('/apartment/zones').getChildren();
    for (var iIndex=0;iIndex<oZoneArray.length;iIndex++) {
    	var iZoneID=oZoneArray[iIndex].getChild('ZoneID').getValue();
    	if (iZoneID!=0) {
    		var zZone = getZoneByID(iZoneID);    		
    		var oldConfig = zZone.getTemperatureControlConfiguration();
    		if (oldConfig.IsConfigured)
	    		if (oldConfig.ControlMode != 0) {
	    		    Property.setProperty('system/preventUninstall',true);
	    		    Property.setFlag('system/preventUninstall', 'ARCHIVE', true);
	    		    return;
	    		}    		
    	}
    }
    Property.setProperty('system/preventUninstall',false);
    Property.setFlag('system/preventUninstall', 'ARCHIVE', true);
}

if (raisedEvent.name == 'heating-controller.controller-config') {
	if (raisedEvent.parameter.actions == 'sync') {
	}
	if (raisedEvent.parameter.actions == 'resetControllerMode') {
		Property.load();
		try {
			var zoneID = raisedEvent.parameter.zoneID;
			var zZone = getZoneByID(parseInt('' + zoneID, 10));

			/*
			 * oParameter.ControlMode = oDataObject.controllerMode;
			 * oParameter.id = iZoneID;
			 * 
			 * oParameter.CtrlDSUID = me.getDSMPIDForZone(iZoneID);
			 * oParameter.ControlDSUID = me.getDSMPIDForZone(iZoneID);
			 */

			var dSM = getDSMPIDForZone(zoneID);
			if (dSM == null) {
				lWarn.logln('no dsm found for zone ' + zoneID);
				new Event('heating-controller.answer', {
					'requestingEvent' : 'heating-controller.controller-config',
					'requestingAction' : 'resetControllerMode',
					'result' : -1
				}).raise();
			} else {
				zZone.setTemperatureControlConfiguration(dSM, {
					ControlMode : 0
				});
				lInfo.logln('remove controller from zone ' + zoneID + ' altogether');
				zZone.setTemperatureControlConfiguration("0000000000000000000000000000000000");


				storeParameter('controllerConfig/' + raisedEvent.parameter.zoneID + '/zoneID', raisedEvent.parameter.zoneID);

				var defID = DefinitionIDs.ModeOff;
				if (raisedEvent.parameter.definitionID != null) {
					defID = parseInt(raisedEvent.parameter.definitionID);
				}
				storeParameter('controllerConfig/' + raisedEvent.parameter.zoneID + '/definitionID', defID);

				if (raisedEvent.parameter.autoselect == null) {
					Property.getNode('controllerConfig/' + raisedEvent.parameter.zoneID).removeChild('autoselect');
				}
				else {
					storeParameter('controllerConfig/' + raisedEvent.parameter.zoneID + '/autoselect', raisedEvent.parameter.autoselect);
				}
				Property.store();

				new Event('heating-controller.answer', {
					'requestingEvent' : 'heating-controller.controller-config',
					'requestingAction' : 'resetControllerMode',
					'result' : 0
				}).raise();
			}
		} catch (e) {
			lWarn.logln('Error on heating-controller.controller-config ' + e);
		}
		new Event('heating-controller.controller-config', {
			'actions' : 'checkPreventUninstall'
		}).raise();
	}
	if ((raisedEvent.parameter.actions == 'setControllerModeAutomatic') &&
		(raisedEvent.parameter.autoselect != null)) {
		lInfo.logln('enable autoselection of pid controller configuration for zone ' + raisedEvent.parameter.zoneID);
		var oldDefinitionID = parseInt("" + Property.getProperty('controllerConfig/' + raisedEvent.parameter.zoneID + '/definitionID'),10);
		var oldAutomatic = parseInt("" + Property.getProperty('controllerConfig/' + raisedEvent.parameter.zoneID + '/autoselect'),10);

		storeParameter('controllerConfig/' + raisedEvent.parameter.zoneID + '/zoneID', raisedEvent.parameter.zoneID);
		storeParameter('controllerConfig/' + raisedEvent.parameter.zoneID + '/autoselect', raisedEvent.parameter.autoselect);
		storeParameter('controllerConfig/' + raisedEvent.parameter.zoneID + '/emergenyValue', raisedEvent.parameter.emergency);
		// reset template ID to unknown if there was a previous selection
		if (oldAutomatic != 1) {
			storeParameter('controllerConfig/' + raisedEvent.parameter.zoneID + '/definitionID', raisedEvent.parameter.definitionID);
			new Event('heating-controller.autoselect', {
				'zoneID' : raisedEvent.parameter.zoneID
				
			}).raise();
		} else {
			var zZone = getZoneByID(parseInt('' + raisedEvent.parameter.zoneID, 10));
			var oldConfig = zZone.getTemperatureControlConfiguration();
			oldConfig.EmergencyValue=raisedEvent.parameter.emergency;
			zZone.setTemperatureControlConfiguration(oldConfig.ControlDSUID, oldConfig);
			new Event('heating-controller.answer', {
				'requestingEvent' : 'heating-controller.controller-config',
				'requestingAction' : 'setControllerModeAutomatic',
				'result' : 0
			}).raise();
		}
		Property.store();
	}
	if (raisedEvent.parameter.actions == 'setControllerModePID') {
		Property.load();
		try {
			var zoneID = raisedEvent.parameter.zoneID;
			var dSM = getDSMPIDForZone(zoneID);
			if (dSM == null) {
				lWarn.logln('no heating controller found for zone ' + zoneID);
				autoSelectDsm(zoneID);
				dSM = getDSMPIDForZone(zoneID);
			}
			if (dSM == null) {
				lWarn.logln('no heating controller could be allocated for zone ' + zoneID);
				new Event('heating-controller.answer', {
					'requestingEvent' : 'heating-controller.controller-config',
					'requestingAction' : 'setControllerModePID',
					'result' : -1
				}).raise();
			} else {
				var zZone = getZoneByID(parseInt('' + zoneID, 10));
				var oldConfig = zZone.getTemperatureControlConfiguration();
				var fNewValues = ((oldConfig.ControlMode != 1) && (oldConfig.ControlMode != 4));

				if (raisedEvent.parameter.autoselect == null) {
					if (Property.getNode('controllerConfig/' + raisedEvent.parameter.zoneID)!=null)
						Property.getNode('controllerConfig/' + raisedEvent.parameter.zoneID).removeChild('autoselect');
				}
				else {
					storeParameter('controllerConfig/' + raisedEvent.parameter.zoneID + '/autoselect', raisedEvent.parameter.autoselect);
				}

				var oParameter = {
					ControlMode : 1,
					EmergencyValue : 75
				};
				if (raisedEvent.parameter.emergency!=null)
					oParameter.EmergencyValue=raisedEvent.parameter.emergency;
				else if (Property.getNode('controllerConfig/' + raisedEvent.parameter.zoneID + '/emergenyValue')!=null) {
					lInfo.logln('found a existing emergeny value ' + Property.getProperty('controllerConfig/' + raisedEvent.parameter.zoneID + '/emergenyValue'));
					oParameter.EmergencyValue=Property.getProperty('controllerConfig/' + raisedEvent.parameter.zoneID + '/emergenyValue');
				}
				oParameter.CtrlKp = parseFloat("" + Property.getProperty('controllerDefinitions/' + raisedEvent.parameter.definitionID + '/kp'));
				oParameter.CtrlTs =  parseFloat("" + Property.getProperty('controllerDefinitions/' + raisedEvent.parameter.definitionID + '/ts'));
				oParameter.CtrlTi =  parseFloat("" + Property.getProperty('controllerDefinitions/' + raisedEvent.parameter.definitionID + '/ti'));
				oParameter.CtrlKd =  parseFloat("" + Property.getProperty('controllerDefinitions/' + raisedEvent.parameter.definitionID + '/kd'));
				oParameter.CtrlImin = parseFloat("" + Property.getProperty('controllerDefinitions/' + raisedEvent.parameter.definitionID + '/imin'));
				oParameter.CtrlImax = parseFloat("" + Property.getProperty('controllerDefinitions/' + raisedEvent.parameter.definitionID + '/imax'));
				oParameter.CtrlYmin = Property.getProperty('controllerDefinitions/' + raisedEvent.parameter.definitionID + '/ymin');
				oParameter.CtrlYmax = Property.getProperty('controllerDefinitions/' + raisedEvent.parameter.definitionID + '/ymax');
				oParameter.CtrlAntiWindUp = ((Property.getProperty('controllerDefinitions/' + raisedEvent.parameter.definitionID + '/antiwindup')!=0)?true:false);
				oParameter.CtrlKeepFloorWarm = ((Property.getProperty('controllerDefinitions/' + raisedEvent.parameter.definitionID + '/keepfloorwarm')!=0)?true:false);
				lInfo.logln('setting pid values to ' + JSON.stringify(oParameter));
				zZone.setTemperatureControlConfiguration(dSM, oParameter);
				storeParameter('controllerConfig/' + raisedEvent.parameter.zoneID + '/zoneID', raisedEvent.parameter.zoneID);
				storeParameter('controllerConfig/' + raisedEvent.parameter.zoneID + '/definitionID', raisedEvent.parameter.definitionID);
				storeParameter('controllerConfig/' + raisedEvent.parameter.zoneID + '/emergenyValue', oParameter.EmergencyValue);
				
				if (fNewValues) {
					lInfo.logln('!!! Changing controlmode -> Reseting temperature Values');
					zZone.setTemperatureControlValues(defaultTemperatureValues, defaultTemperatureValues);
				}
				Property.store();
				new Event('heating-controller.answer', {
					'requestingEvent' : 'heating-controller.controller-config',
					'requestingAction' : 'setControllerModePID',
					'result' : 0
				}).raise();

				// new
				// Event('HeatingControllerSetup',{'zoneID':zoneID,'HeatingControllerTypeId':raisedEvent.parameter.definitionID}).raise();
				var handle = new WebserviceConnection();
				var queryString='heatingControllerTypeId=' + raisedEvent.parameter.definitionID + '&zoneid=' + raisedEvent.parameter.zoneID+ '&dSSId=' + getMyDSID();
				lInfo.logln('public/dss/v1_1/DSSHeating/SetHeatingControllerType ' + queryString);
				handle.request('public/dss/v1_1/DSSHeating/SetHeatingControllerType',queryString , 'POST', {
					'Content-Type' : 'application/json',
					'NotificationTextIsUrlEncodedUtf7' : 'true'
				}, '', true, function(code, retdata) {
					if (code === 200) {
						lInfo.logln(': OK [' + code + ']');
					} else {
						lWarn.logln(': FAILED! Server replied: "' + code + '"');
					}
					lInfo.logln(retdata);
				});
				new Event('heating-controller.operation-mode',{'zoneID':zoneID,'actions':'evaluateRealActiveMode'}).raise();
			}
		} catch (e) {
			lWarn.logln('Error on heating-controller.controller-config ' + e);
		}
		new Event('heating-controller.controller-config', {
			'actions' : 'checkPreventUninstall'
		}).raise();
	}
	if (raisedEvent.parameter.actions == 'setControllerModeZoneFollower') {
		Property.load();
		try {
			var zoneID = raisedEvent.parameter.zoneID;
			var dSM = getDSMPIDForZone(zoneID);
			if (dSM == null) {
				lWarn.logln('no heating controller found for zone ' + zoneID);
				autoSelectDsm(zoneID);
				dSM = getDSMPIDForZone(zoneID);
			}
			if (dSM == null) {
				lWarn.logln('no heating controller could be allocated for zone ' + zoneID);
				new Event('heating-controller.answer', {
					'requestingEvent' : 'heating-controller.controller-config',
					'requestingAction' : 'setControllerModeZoneFollower',
					'result' : -1
				}).raise();
			} else {
				var offset = raisedEvent.parameter.offset;
				var followedZone = raisedEvent.parameter.followedZone;
				var zZone = getZoneByID(parseInt('' + zoneID, 10));
				var oParameter ={
					ControlMode : 2,
					ReferenceZone : followedZone,
					CtrlOffset : offset,
					EmergencyValue : 75
				};
				if (raisedEvent.parameter.emergency!=null)
					oParameter.EmergencyValue=raisedEvent.parameter.emergency;

				zZone.setTemperatureControlConfiguration(dSM, oParameter);
				
				
				storeParameter('controllerConfig/' + raisedEvent.parameter.zoneID + '/zoneID', raisedEvent.parameter.zoneID);
				storeParameter('controllerConfig/' + raisedEvent.parameter.zoneID + '/definitionID', DefinitionIDs.ModeZoneFollower);
				storeParameter('controllerConfig/' + raisedEvent.parameter.zoneID + '/offset', offset);
				storeParameter('controllerConfig/' + raisedEvent.parameter.zoneID + '/followedZone', followedZone);
				storeParameter('controllerConfig/' + raisedEvent.parameter.zoneID + '/emergenyValue', oParameter.EmergencyValue);

				if (raisedEvent.parameter.autoselect == null) {
					Property.getNode('controllerConfig/' + raisedEvent.parameter.zoneID).removeChild('autoselect');
				}
				else {
					storeParameter('controllerConfig/' + raisedEvent.parameter.zoneID + '/autoselect', raisedEvent.parameter.autoselect);
				}

				Property.store();
				new Event('heating-controller.answer', {
					'requestingEvent' : 'heating-controller.controller-config',
					'requestingAction' : 'setControllerModeZoneFollower',
					'result' : 0
				}).raise();				
			}
		} catch (e) {
			lWarn.logln('Error on heating-controller.controller-config ' + e);
		}
		new Event('heating-controller.controller-config', {
			'actions' : 'checkPreventUninstall'
		}).raise();
	}
	if (raisedEvent.parameter.actions == 'setControllerModeFixedValue') {
		Property.load();
		try {
			var zoneID = raisedEvent.parameter.zoneID;
			var dSM = getDSMPIDForZone(zoneID);
			if (dSM == null) {
				lWarn.logln('no heating controller found for zone ' + zoneID);
				autoSelectDsm(zoneID);
				dSM = getDSMPIDForZone(zoneID);
			}
			if (dSM == null) {
				lWarn.logln('no heating controller could be allocated for zone ' + zoneID);
				new Event('heating-controller.answer', {
					'requestingEvent' : 'heating-controller.controller-config',
					'requestingAction' : 'setControllerModeFixedValue',
					'result' : -1
				}).raise();
			} else {
				var zZone = getZoneByID(parseInt('' + zoneID, 10));
				var oldConfig = zZone.getTemperatureControlConfiguration();
				var fNewValues = ((oldConfig.ControlMode != 3) && (oldConfig.ControlMode != 4));
				zZone.setTemperatureControlConfiguration(dSM, {
					ControlMode : 3
				});

				storeParameter('controllerConfig/' + raisedEvent.parameter.zoneID + '/zoneID', raisedEvent.parameter.zoneID);
				storeParameter('controllerConfig/' + raisedEvent.parameter.zoneID + '/definitionID', DefinitionIDs.ModeFixedValue);

				if (raisedEvent.parameter.autoselect == null) {
					Property.getNode('controllerConfig/' + raisedEvent.parameter.zoneID).removeChild('autoselect');
				}
				else {
					storeParameter('controllerConfig/' + raisedEvent.parameter.zoneID + '/autoselect', raisedEvent.parameter.autoselect);
				}

				if (fNewValues) {
					lInfo.logln('!!! Changing controlmode -> Reseting temperature Values');
					zZone.setTemperatureControlValues(defaultFixedValues, defaultFixedValues);
				}

				Property.store();
				new Event('heating-controller.answer', {
					'requestingEvent' : 'heating-controller.controller-config',
					'requestingAction' : 'setControllerModeFixedValue',
					'result' : 0
				}).raise();
				new Event('heating-controller.operation-mode',{'zoneID':zoneID,'actions':'evaluateRealActiveMode'}).raise();
			}
		} catch (e) {
			lWarn.logln('Error on heating-controller.controller-config ' + e);
		}
		new Event('heating-controller.controller-config', {
			'actions' : 'checkPreventUninstall'
		}).raise();
	}
	if (raisedEvent.parameter.actions == 'setControllerModeManual') {
		Property.load();
		try {
			storeParameter('controllerConfig/' + raisedEvent.parameter.zoneID + '/zoneID', raisedEvent.parameter.zoneID);
			storeParameter('controllerConfig/' + raisedEvent.parameter.zoneID + '/fManualOverride', true);

			if (raisedEvent.parameter.autoselect == null) {
				Property.getNode('controllerConfig/' + raisedEvent.parameter.zoneID).removeChild('autoselect');
			}
			else {
				storeParameter('controllerConfig/' + raisedEvent.parameter.zoneID + '/autoselect', raisedEvent.parameter.autoselect);
			}

			var manualValue = 0;
			if (raisedEvent.parameter.value != null)
				manualValue = parseInt('' + raisedEvent.parameter.value, 10);
			var zZone = getZoneByID(parseInt('' + raisedEvent.parameter.zoneID, 10));
			lInfo.logln('setControllerModeManual for zone ' + raisedEvent.parameter.zoneID);
			var dSM = getDSMPIDForZone(raisedEvent.parameter.zoneID);
			zZone.setTemperatureControlConfiguration(dSM, {
				ControlMode : 4,
				ManualValue : manualValue
			});
			Property.store();
			new Event('heating-controller.answer', {
				'requestingEvent' : 'heating-controller.controller-config',
				'requestingAction' : 'setControllerModeManual',
				'result' : 0
			}).raise();			
		} catch (e) {
			lWarn.logln('Error ' + e);
		}
		new Event('heating-controller.controller-config', {
			'actions' : 'checkPreventUninstall'
		}).raise();
	}
	if (raisedEvent.parameter.actions == 'checkPreventUninstall') {
		preventUninstall();
        Property.store();
	}
	if (raisedEvent.parameter.actions == 'resetControllerModeManual') {
		Property.load();
		try {

			storeParameter('controllerConfig/' + raisedEvent.parameter.zoneID + '/zoneID', raisedEvent.parameter.zoneID);
			storeParameter('controllerConfig/' + raisedEvent.parameter.zoneID + '/fManualOverride', false);
			Property.store();

			var definitionID = Property.getProperty('controllerConfig/' + raisedEvent.parameter.zoneID + '/definitionID');
			if (definitionID == null) {
				lInfo.logln('resetControllerModeManual for zone ' + raisedEvent.parameter.zoneID + ' to OFF');
				new Event('heating-controller.controller-config', {
					'zoneID' : raisedEvent.parameter.zoneID,
					'actions' : 'resetControllerMode'
				}).raise();
			} else if (definitionID == DefinitionIDs.ModeOff) {
				lInfo.logln('resetControllerModeManual for zone ' + raisedEvent.parameter.zoneID + ' to OFF');
				new Event('heating-controller.controller-config', {
					'zoneID' : raisedEvent.parameter.zoneID,
					'actions' : 'resetControllerMode'
				}).raise();
			} else if (definitionID == DefinitionIDs.ModeZoneFollower) {
				lInfo.logln('resetControllerModeManual for zone ' + raisedEvent.parameter.zoneID + ' to zoneFollower');
				var offset = Property.getProperty('controllerConfig/' + raisedEvent.parameter.zoneID + '/offset');
				var followedZone = Property.getProperty('controllerConfig/' + raisedEvent.parameter.zoneID + '/followedZone');
				var emergenyValue = Property.getProperty('controllerConfig/' + raisedEvent.parameter.zoneID + '/emergenyValue');
				
				
				new Event('heating-controller.controller-config', {
					'zoneID' : raisedEvent.parameter.zoneID,
					'actions' : 'setControllerModeZoneFollower',
					'offset' : offset,
					'followedZone' : followedZone,
					'emergency': emergenyValue
				}).raise();
			} else if (definitionID == DefinitionIDs.ModeFixedValue) {
				lInfo.logln('resetControllerModeManual for zone ' + raisedEvent.parameter.zoneID + ' to fixedValue');
				new Event('heating-controller.controller-config', {
					'zoneID' : raisedEvent.parameter.zoneID,
					'actions' : 'setControllerModeFixedValue'
				}).raise();
			} else if (definitionID > 0) {
				var emergenyValue = Property.getProperty('controllerConfig/' + raisedEvent.parameter.zoneID + '/emergenyValue');
				
				lInfo.logln('resetControllerModeManual for zone ' + raisedEvent.parameter.zoneID + ' to PID with definition ' + definitionID);
				new Event('heating-controller.controller-config', {
					'zoneID' : raisedEvent.parameter.zoneID,
					'actions' : 'setControllerModePID',
					'definitionID' : definitionID,
					'emergency': emergenyValue
				}).raise();
			}
			new Event('heating-controller.answer', {
				'requestingEvent' : 'heating-controller.controller-config',
				'requestingAction' : 'setControllerModeManual',
				'result' : 0
			}).raise();
		} catch (e) {
			lWarn.logln('Error ' + e);
		}
		new Event('heating-controller.controller-config', {
			'actions' : 'checkPreventUninstall'
		}).raise();
	}
}
